////////////////////////////////////////////////////////////////////////////////
//Code stub generated with:
//                                Crocus Modeller
//                      Robust UML editor for AS3 & Flex devs.
//                             http://CrocusModeller.com
//
////////////////////////////////////////////////////////////////////////////////


package hmartin.socketService.model.vos {
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.OutputProgressEvent;
	import flash.events.ProgressEvent;
	import flash.net.Socket;
	
	import org.osflash.signals.Signal;

	/**
	 * hmartin.socketService.model.vos.BufferedSocket
	 *
	 * @author Harold MARTIN
	 */
	public class BufferedSocket extends Socket {
		///////////////////////
		// PROPERTIES
		///////////////////////
		
		public static const END_OF_LINE_CHARS:String = "\r\n";
		
		protected var buffer : String = "";
		private var _connectedSignal : Signal = new Signal(BufferedSocket);
		private var _disconnectedSignal : Signal = new Signal(BufferedSocket);
		private var _datasSentSignal : Signal = new Signal(BufferedSocket);
		private var _datasReceivedSignal : Signal = new Signal(BufferedSocket,String);
		private var _errorReceivedSignal : Signal = new Signal(BufferedSocket,String);

		///////////////////////
		// METHODS
		///////////////////////
		
		override public function connect(host : String, port : int) : void {
			this.addEventListener(Event.CONNECT,connectedHandler);
			this.addEventListener(Event.CLOSE,closedHandler);
			this.addEventListener(IOErrorEvent.IO_ERROR,ioErrorHandler);
			this.addEventListener(OutputProgressEvent.OUTPUT_PROGRESS,datasSentHandler);
			this.addEventListener(ProgressEvent.SOCKET_DATA,datasReceivedHandler);
			super.connect(host,port);
		}

		public function disconnect() : void {
			this.removeEventListener(Event.CONNECT,connectedHandler);
			this.removeEventListener(Event.CLOSE,closedHandler);
			this.removeEventListener(IOErrorEvent.IO_ERROR,ioErrorHandler);
			this.removeEventListener(OutputProgressEvent.OUTPUT_PROGRESS,datasSentHandler);
			this.removeEventListener(ProgressEvent.SOCKET_DATA,datasReceivedHandler);
			if(this.connected)
				super.close();
			disconnectedSignal.dispatch(this);
		}

		public function sendDatas(datas : String) : void {
			super.writeUTFBytes(datas);
			super.flush();
		}

		protected function connectedHandler(event : Event) : void {
			connectedSignal.dispatch(this);
		}

		protected function closedHandler(event : Event) : void {
			this.disconnect();
		}

		protected function ioErrorHandler(event : IOErrorEvent) : void {
			errorReceivedSignal.dispatch(this,event.text);
		}

		protected function datasReceivedHandler(event : ProgressEvent) : void {
			buffer += this.readUTFBytes(this.bytesAvailable);
			var endOfLineIndex:int = buffer.indexOf(END_OF_LINE_CHARS);
			while(endOfLineIndex > -1){
				datasReceivedSignal.dispatch(this,buffer.slice(0,endOfLineIndex));
				buffer = buffer.slice(endOfLineIndex+END_OF_LINE_CHARS.length);
				endOfLineIndex = buffer.indexOf(END_OF_LINE_CHARS);
			}
		}

		protected function datasSentHandler(event : OutputProgressEvent) : void {
			datasSentSignal.dispatch(this);
		}

		///////////////////////
		// GETTERS/SETTERS
		///////////////////////
		
		public function get connectedSignal() : Signal {
			return _connectedSignal;
		}

		public function get disconnectedSignal() : Signal {
			return _disconnectedSignal;
		}

		public function get datasSentSignal() : Signal {
			return _datasSentSignal;
		}

		public function get datasReceivedSignal() : Signal {
			return _datasReceivedSignal;
		}

		public function get errorReceivedSignal() : Signal {
			return _errorReceivedSignal;
		}


	}
}