////////////////////////////////////////////////////////////////////////////////
//Code stub generated with:
//                                Crocus Modeller
//                      Robust UML editor for AS3 & Flex devs.
//                             http://CrocusModeller.com
//
////////////////////////////////////////////////////////////////////////////////


package hmartin.socketService.service.impl {
	import flash.utils.Dictionary;
	
	import hmartin.socketService.controller.requests.RequestUpdateDeviceConnectionStatus;
	import hmartin.socketService.model.vos.BufferedSocket;
	import hmartin.socketService.model.vos.ConnectionStatus;
	import hmartin.socketService.model.vos.IConnectableDevice;
	import hmartin.socketService.service.api.ISocketService;
	import hmartin.socketService.service.notifications.NotifyDatasReceivedFromDevice;
	import hmartin.socketService.service.notifications.NotifyDatasSentToDevice;
	import hmartin.socketService.service.notifications.NotifyDeviceConnected;
	import hmartin.socketService.service.notifications.NotifyDeviceDisconnected;
	import hmartin.socketService.service.notifications.NotifyErrorReceivedFromDevice;

	/**
	 * hmartin.socketService.service.impl.AbstractSocketService
	 *
	 * @author Harold MARTIN
	 */
	public class AbstractSocketService implements ISocketService {
		///////////////////////
		// PROPERTIES
		///////////////////////
		
		private var _socketsByDevices : Dictionary = new Dictionary();
		private var _devicesBySockets : Dictionary = new Dictionary();

		[Inject]public var notifyDeviceConnected:NotifyDeviceConnected;
		[Inject]public var notifyDeviceDisconnected:NotifyDeviceDisconnected;
		[Inject]public var notifyDatasSentToDevice:NotifyDatasSentToDevice;
		[Inject]public var notifyDatasReceivedFromDevice:NotifyDatasReceivedFromDevice;
		[Inject]public var notifyErrorReceivedFromDevice:NotifyErrorReceivedFromDevice;
		[Inject]public var requestUpdateDeviceConnectionStatus:RequestUpdateDeviceConnectionStatus;
		
		///////////////////////
		// METHODS
		///////////////////////
		
		public function getSocketByDevice(device : IConnectableDevice) : BufferedSocket {
			return socketsByDevices[device];
		}

		public function getDeviceBySocket(socket : BufferedSocket) : IConnectableDevice {
			return devicesBySockets[socket];
		}

		protected function createSocket(device : IConnectableDevice) : BufferedSocket {
			var socket:BufferedSocket = new BufferedSocket();
			socketsByDevices[device] = socket;
			devicesBySockets[socket] = device;
			socket.connectedSignal.add(function(bsocket:BufferedSocket):void{
				notifyDeviceConnected.dispatch(getDeviceBySocket(bsocket));
			});
			socket.disconnectedSignal.add(function(bsocket:BufferedSocket):void{
				notifyDeviceDisconnected.dispatch(getDeviceBySocket(bsocket));
			});
			socket.datasReceivedSignal.add(function(bsocket:BufferedSocket,datas:String):void{
				notifyDatasReceivedFromDevice.dispatch(getDeviceBySocket(bsocket),datas);
			});
			socket.datasSentSignal.add(function(bsocket:BufferedSocket):void{
				notifyDatasSentToDevice.dispatch(getDeviceBySocket(bsocket));
			});
			socket.errorReceivedSignal.add(function(bsocket:BufferedSocket,error:String):void{
				notifyErrorReceivedFromDevice.dispatch(getDeviceBySocket(bsocket),error);
			});
			return socket;
		}

		protected function destroySocket(device : IConnectableDevice) : BufferedSocket {
			var socket:BufferedSocket = getSocketByDevice(device);
			socket.connectedSignal.removeAll();
			socket.disconnectedSignal.removeAll();
			socket.errorReceivedSignal.removeAll();
			socket.datasReceivedSignal.removeAll();
			socket.datasSentSignal.removeAll();
			
			delete socketsByDevices[device];
			delete devicesBySockets[socket];
			
			return socket;
		}

		public function connect(device : IConnectableDevice) : void {
			requestUpdateDeviceConnectionStatus.dispatch(device,new ConnectionStatus(true,false));
			createSocket(device).connect(device.connectionInfos.ip,device.connectionInfos.port);
		}

		public function disconnect(device : IConnectableDevice) : void {
			destroySocket(device).disconnect();
			requestUpdateDeviceConnectionStatus.dispatch(new ConnectionStatus(false,false));
		}

		public function sendDatasToDevice(device : IConnectableDevice,datas:String) : void {
			getSocketByDevice(device).sendDatas(datas);
		}

		///////////////////////
		// GETTERS/SETTERS
		///////////////////////
		
		protected function get socketsByDevices() : Dictionary {
			return _socketsByDevices;
		}

		protected function set socketsByDevices(value : Dictionary) : void {
			_socketsByDevices = value;
		}

		protected function get devicesBySockets() : Dictionary {
			return _devicesBySockets;
		}

		protected function set devicesBySockets(value : Dictionary) : void {
			_devicesBySockets = value;
		}


	}
}